/*
 * CS5App.java     Connect Four: the Player class
 *
 * Homework # 11
 * Problem  #  1
 *
 * Pair Programming Problem
 *
 * Name(s):
 * Date:
 * Time spent:
 *
 * Comments:  
 * 
 *
 */

import java.awt.*;

class CS5App
{
    public static void main(String[] args)
    {
        H.pl("Welcome to Connect Four!");
		int nrows = 6;   // in this problem, we will only use
		int ncols = 7;   // the standard-sized connect-four board
		H.pl("\n\n");
		
		Board b = new Board(nrows, ncols);
		
		// uncomment these three lines for graphical interface
		// GrCanvas C = G.createCanvas();
		// GrCFour CF = new GrCFour(b.getData());
		// C.add(CF);
		
		// here, you will need to ask for the lookahead level
		// and the tie-breaking rule used by each of the two Players
		
		// the player variable should change from char to Player
		char player = 'X';
		int uc = 0;
		
		while (true)
		{
            b.print();
            // C.repaint();
            
			uc = H.ni(player + "'s move:");
			while ( !b.allowsMove(uc) )
			{
                uc = H.ni(player + "'s move:");
			}

			// add the move to the board
			H.pl("\n");
			b.addMove(uc,player);
			
			if (b.winsFor(player))
			{
			    b.print();
                // C.repaint();
				H.pl("\n\nPlayer " + player + " wins! Congratulations!\n\n");
				break;
			}
			
			if (b.isFull())
			{
			    b.print();
                // C.repaint();
				H.pl("\n\nThe board is full and the game is a draw!\n\n");
				break;
			}
			
			// swap the player
			if (player == 'X')
			    player = 'O';
			else
			    player = 'X';
		}
	}
	
} // end of CS5App class









/*
 * The Board class represents a connect-four board of almost arbitrary size
 */
class Board
{
	private int nrows;
	private int ncols;
	private char[][] data;
	
	/* Board constructor
	 * inputs: number of rows and number of columns
	 */
	public Board(int nr, int nc)
	{
		this.data = new char[nr][nc];
		nrows = data.length;
		ncols = data[0].length;
		
		for (int r=0 ; r<nrows ; ++r)
			for (int c=0 ; c<ncols ; ++c)
				data[r][c] = ' ';   // spaces to start
	}
	
	/* getData method -- returns the underlying board representation
	 * inputs: none
	 * outputs: a 2d array of chars: 'X' 'O' or ' '
	 */
	public char[][] getData()
	{
		return data;
	}
	
	/* print method -- prints the board that calls it to the console
	 * inputs: none
	 * outputs: none
	 */
	public void print()
	{
		for (int r=0 ; r<nrows ; ++r)
		{
			for (int c=0 ; c<ncols ; ++c)
			{
				H.p("|" + data[r][c]);
			}
			H.pl("|");
		}
		
		for (int c=0 ; c<ncols ; ++c)
		{
			H.p("--");
		}
		H.pl("-");
		
		for (int c=0 ; c<ncols ; ++c)
		{
			H.p(" "+(c%10));
		}
		H.pl("\n\n");
	}
	
	/* addMove -- adds a move to column c for player
	 * inputs: the column to move to (c) and the char to put there (player)
	 * outputs: none
	 */
	public void addMove(int c, char player)
	{
		if (this.allowsMove(c))
		{
			int r = nrows-1;
			while (data[r][c] != ' ')
			{
				--r;
			}
			data[r][c] = player;
		}
	}
	
	/* allowsMove -- determines if a move is allowed to column c
	 * inputs: the column to check (c)
	 * outputs: true if a player can move to c, false otherwise
	 */
	public boolean allowsMove(int c)
	{
	   if (c>=ncols || c<0) return false;
	   if (data[0][c] == ' ') return true;
	   return false;
	}
	
    /* isFull -- determines if this Board is full
     * inputs: none
     * outputs: true if the board is full, false otherwise
     */
	public boolean isFull()
	{
	    for (int c=0 ; c<ncols ; ++c)
	        if (allowsMove(c))
	            return false;
	            
        return true;
	}
	
    /* winsFor -- determines if this Board wins for a 
     * inputs: the char representing the player
     * outputs: true if the board is full, false otherwise
     */
	public boolean winsFor(char player)
	{
	    // horizontal
	    for (int r=0 ; r<nrows ; ++r)
            for (int c=0 ; c<ncols-3 ; ++c)
                if (data[r][c  ] == player &&
                    data[r][c+1] == player &&
                    data[r][c+2] == player &&
                    data[r][c+3] == player)
                    return true;
        
        // vertical
        for (int r=0 ; r<nrows-3 ; ++r)
            for (int c=0 ; c<ncols ; ++c)
                if (data[r  ][c] == player &&
                    data[r+1][c] == player &&
                    data[r+2][c] == player &&
                    data[r+3][c] == player)
                    return true;
                    
        // NW - SE diagonal            
        for (int r=0 ; r<nrows-3 ; ++r)
            for (int c=0 ; c<ncols-3 ; ++c)
                if (data[r  ][c  ] == player &&
                    data[r+1][c+1] == player &&
                    data[r+2][c+2] == player &&
                    data[r+3][c+3] == player)
                    return true;
                    
        // NE - SW diagonal            
        for (int r=3 ; r<nrows ; ++r)
            for (int c=0 ; c<ncols-3 ; ++c)
                if (data[r  ][c  ] == player &&
                    data[r-1][c+1] == player &&
                    data[r-2][c+2] == player &&
                    data[r-3][c+3] == player)
                    return true;                        
                                
		return false;	
	}
	
	
} // end of the Board class

